/***************************************************************************
 *   Copyright (C) 2009 by Fabian Wuertz                                   *
 *   xadras@sidux.com                                                      *
 *   Project: Waheela                                                      *
 *   File:    waheela.h                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef waheela_H
#define waheela_H


#include <QtGui/QtGui>
#include <KConfigDialog>
#include <KAboutApplicationDialog>

#include "ui_waheela.h"
#include "ui_amarokSettings.h"
#include "ui_metadataSettings.h"
#include "ui_dateSettings.h"
#include "ui_themeSettings.h"
#include "ui_passwordSettings.h"

#include <kde_terminal_interface.h>
#include <kparts/part.h>
#include <KUser>

class Waheela : public QWidget, Ui::Waheela
{
	Q_OBJECT
	public:
		Waheela();
		void initSettingsDialog();
		void initAboutDialog();
		void mousePressEvent(QMouseEvent  *event);
		void wheelEvent(QWheelEvent *event);
		void paintEvent(QPaintEvent *);

	public slots:
		virtual void playSong();
		virtual void stopSong();
		virtual void prevSong();
		virtual void nextSong();
		virtual void hideButtons();
		virtual void updateMetadata(const QVariantMap&);
		virtual void setPosition(const int, const int);
		virtual void configAccepted();
		virtual void updateClock();
		virtual void setPassword(QString);
		void setStatus(const int &);


	private:
		KConfigDialog* dialog;
		KAboutApplicationDialog* aboutDialog;
		Ui::amarokPage amarokUi;
		Ui::metadataPage metadataUi;
		Ui::datePage dateUi;
		Ui::themesPage themesUi;
		Ui::passwordPage passwordUi;
	  	QString theme, password, pwd;
		bool showCover, showDate, showTime, useCustomMetadataFont, useCustomDateFont, usePassword;
		QFont metadataFont, metadataDefaultFont, dateFont, dateDefaultFont;
		QMouseEvent* globalEvent;
		QTimer *timer;
		bool wideScreen;



};

#endif
